#include "common.h"
static uint8_t tx_buffer[TR_BUFF_SIZE];
static uint8_t rx_buffer[TR_BUFF_SIZE];

int main()
{
	uint32_t rx_sum = 0;
	uint32_t tx_sum = 0;
	uint8_t tmp;


	init();
	// initialize buffers with some known value
	memset(tx_buffer,0x33,sizeof(tx_buffer));
	memset(rx_buffer,0x44,sizeof(rx_buffer));
	for(int i = 0; i < TR_BUFF_SIZE; i++)
	{
		tx_buffer[i] = 0x33 + i;
	}

	// wait for keystroke: this gives the user time to start the slave
    Report("Start the slave and press any key to transmit data....\n\r");
    MAP_UARTCharGet(UARTA0_BASE);
	
	// configure SPI channel
	MAP_SPIReset(GSPI_BASE);
    MAP_SPIConfigSetExpClk(GSPI_BASE,MAP_PRCMPeripheralClockGet(PRCM_GSPI),
                     SPI_IF_BIT_RATE,SPI_MODE_MASTER,SPI_SUB_MODE_0,
                     (SPI_SW_CTRL_CS |
                     SPI_4PIN_MODE |
                     SPI_TURBO_OFF |
                     SPI_CS_ACTIVEHIGH |
                     SPI_WL_8));	
	MAP_SPIEnable(GSPI_BASE);

	// fill buffer with random numbers
	Message("Filling Tx Buffer\n\r");
	/*
	for(int i = 0; i < TR_BUFF_SIZE; i++)
	{
		tmp = xorshift128();
		tx_buffer[i] = tmp;
		tx_sum += tmp;
	}*/
	Report("Sum in the Tx Buffer is: %d\n\r", tx_sum);
	Report("Checksum in the Tx Buffer is: 0x%02x\n\r", crc(tx_buffer));
	Message("Filled Tx Buffer\n\r");

	int count = 0;
	while(1)
	{
		Message("Sending...");
		MAP_SPITransfer(GSPI_BASE,tx_buffer,rx_buffer, TR_BUFF_SIZE,
				SPI_CS_ENABLE|SPI_CS_DISABLE);
		rx_sum = 0;
		for(int i = 0; i < TR_BUFF_SIZE; i++)
		{
			rx_sum += rx_buffer[i];
		}
		Report("The sum in the Rx buffer is: %d, tx was : %d\n\r",rx_sum,tx_sum);
		Report("Checksum in the Rx buffer is: 0x%02x\n\r",crc(rx_buffer));
		Message("TX-");
		print_buffer(tx_buffer,TR_BUFF_SIZE);
		Message("RX-");
		print_buffer(rx_buffer,TR_BUFF_SIZE);
		Report("Press any key to transmit again\n\r");
		MAP_UARTCharGet(UARTA0_BASE);
		for(int i = 0; i < TR_BUFF_SIZE; i++)
		{
			tx_buffer[i] = count++;
		}
	}
	return 0;
}

